
require('babel-core/register')
var gulp  = require('gulp')
var babel = require('gulp-babel')
var runSequence = require('run-sequence')
var del  = require('del')
var minimist = require('minimist');
var mocha = require('gulp-mocha');
var plumber = require('gulp-plumber')
var plugin = require('./lib/index').default
var transformFileSync = require("babel-core").transformFileSync;
var path = require('path')
const DIR = {
	src:"./src/**/*.js",
	test:"./test",
	testes6:"./test_es6",
	dist:"lib"
}
gulp.task('clean',()=>{
	del([DIR.dist])
})
gulp.task('babel',()=>{
	return gulp.src(DIR.src)
	.pipe(plumber())
	.pipe(babel())
	.pipe(gulp.dest(DIR.dist))
})
// gulp.task('babelTest',()=>{
// 	return gulp.src(DIR.testes6+'/**/*.spec.js')
// 	.pipe(plumber())
// 	.pipe(babel({
// 		plugins:[
// 			'../lib/index.js'
// 		]
// 	}))
// 	.pipe(gulp.dest(DIR.test))
// })

gulp.task('babelTest',()=>{
	if(require.cache[require.resolve('./lib/index')]){
		delete require.cache[require.resolve('./lib/index')];
		delete require.cache[require.resolve('./lib/util/parser')]
	}
	var plugin = require('./lib/index').default
	var code = transformFileSync(`./test_es6/index.spec.js`,{
		presets: ['react'],
      	plugins: [
	      	[
	      		plugin,
	      		{
		      	}
	      	]
      	],
	}).code
	require('fs').writeFileSync(path.resolve(__dirname,'./test/index.spec.js'),code)
})

gulp.task('build',(cb)=>{
	runSequence(
		// 'clean',
		'babel',
		'babelTest'
	)
	cb()
})

gulp.task('watch',(cb)=>{
	gulp.watch([DIR.src,DIR.testes6+'/**/*.spec.js'],['build'])
})

gulp.task('test',(cb)=>{
	var options = minimist(process.argv);
	var file = options.file
	gulp.src(`${DIR.testes6}/${file}.spec.js`)
        .pipe(mocha())
        .once('error', (err) => {
        	console.log('err :',err)
            process.exit(1);
        })
        .once('end', () => {
        	console.log('test over')
            process.exit();
        })
})



gulp.task('testAll',(cb)=>{
	gulp.src([`${DIR.testes6}/**/*.spec.js`])
		.pipe(babel())
        .pipe(mocha())
        .once('error', (err) => {
        	console.log('err :',err)
            process.exit(1);
        })
        .once('end', () => {
        	console.log('test over')
            process.exit();
        })
})