'use strict';

import React from 'react';
import ReactDom from 'react-dom'
import { is } from 'immutable'
import './index.less'

const SHOW_CLASSNAME = 'luo-react-render-effect'

export default  (ComposedComponent) => class PureRenderComponent extends React.Component {
  constructor(props){
  	super(props)
  	this.shouldComponentUpdate = ComposedComponent.shouldComponentUpdate
  }
  componentDidMount(){
  	let dom = ReactDom.findDOMNode(this)
  	if(dom){
		this.webkitAnimationEnd = dom.addEventListener("webkitAnimationEnd", function(){ //动画结束时事件 
			this.classList.remove(SHOW_CLASSNAME)
		}, false); 
  	}
  }
  componentWillUnmount(){
    dom.removeEventListener("webkitAnimationEnd",this.webkitAnimationEnd)
    this.webkitAnimationEnd = null
  }
  componentWillUpdate(){
  	let dom = ReactDom.findDOMNode(this)
  	if(dom){
  		dom.classList.add(SHOW_CLASSNAME)
  	}
  }
  render() {
    return <ComposedComponent  {...this.props} {...this.state} />
  }
		
}

